on *:LOAD:{
  echo -a To use, type /weather zipcode or click on the background of a channel and select "Weather Underground".
  echo -a Double click on forecast pictures for a detailed view.
  set %wunderground.metric $false
}
menu channel,status,query {
  - 
  Unload Weather Underground
  .Unload:uninstall
  Weather Underground:weather $?="Enter zip code/city"
  -
}
alias weather {
  if (%wngrnd.specifyLocation != 1) {
    if ($1) { 
      unset %wngrnd*
      unset %wunderground.previousT.*
      if ($chr(32) isin $1-) { set %wngrnd.location $replace($1-,$chr(32),+) }
      else { set %wngrnd.location $1 }
      if (!$dialog(wngrnd)) { dialog -dm wngrnd wngrnd }
      did -r wngrnd 16
      did -a wngrnd 16 $1- 
      if (%wunderground.metric == $false) {
        did -b wngrnd 45
        did -e wngrnd 44
      }
      else {
        did -b wngrnd 44
        did -e wngrnd 45
      }
    }
    else { echo -a Invalid Location. | halt }
  }
  if (!$dialog(wngrnd)) { dialog -dm wngrnd wngrnd }
  set %wngrnd.forecastPicPlacement 1
  set %wngrnd.forecastHiLoPlacement 0
  set %wngrnd.forecastDayPlacement 36
  set %wngrnd.forecastInfoPlacement 25
  set %wngrnd.forecastDetailsPlacement 0
  set %wngrnd.forecastReceive 0
  set %wngrnd.locationAmount 0
  set %wngrnd.receive 1
  set %wngrnd.receivePWeather 0
  unset %wngrnd.PWeatherTemp
  if ($exists($shortfn($scriptdir $+ PWeather.txt))) { write -c $shortfn($scriptdir $+ PWeather.txt) }
  sockclose wngrnd*
  sockopen wngrnd printer.wunderground.com 80
  sockopen wngrnd.forecast wunderground.com 80
}
ON *:SOCKOPEN:wngrnd.forecast:{ 
  if (%wngrnd.specifyLocation != 1) {
    sockwrite -n $sockname GET /cgi-bin/findweather/getForecast?query= $+ %wngrnd.location HTTP/1.0
  }
  else {
    sockwrite -n $sockname GET %wngrnd.location HTTP/1.0
    unset %wngrnd.specifyLocation
  }
  sockwrite -n $sockname Host: www.wunderground.com
  sockwrite -n $sockname Connection: close
  sockwrite -n $sockname $crlf
} 
on *:sockread:wngrnd.forecast:{
  if ($sockerr) {
    echo -a Error.
    halt
  }
  else {
    var %temptext
    sockread %temptext
    if (*Location* iswm %temptext) { if (*Location:* iswm $nohtml(%temptext)) { did -e wngrnd 46 | set %wngrnd.receivePWeather 1 | write $shortfn($scriptdir $+ PWeather.txt) $nohtml(%temptext) } }
    if (*<nobr><b>* iswm %temptext) || (*<td align="center" bgcolor="#ffffff"><div class="smalltext">* iswm %temptext) && (%wngrnd.receivePWeather == 1) { set %wngrnd.PWeatherTemp %wngrnd.PWeatherTemp $nohtml(%temptext) }
    if (*<tr bgcolor="#d3d3d3">* iswm %temptext) && (%wngrnd.receivePWeather == 1) { write $shortfn($scriptdir $+ PWeather.txt) %wngrnd.PWeatherTemp | unset %wngrnd.PWeatherTemp | set %wngrnd.receivePWeather 0 }
    if (%wngrnd.specifyLocation == 1) && (*<td><a href="/* iswm %temptext) {
      inc %wngrnd.locationAmount
      set %wngrnd.locationHref. [ $+ [ %wngrnd.locationAmount ] ] $gettok(%temptext,2,34)
      set %wngrnd.locationName. [ $+ [ %wngrnd.locationAmount ] ] $nohtml(%temptext)
    }
    if (*Search results for: * iswm %temptext) { set %wngrnd.specifyLocation 1 }
    if (*City Not Found* iswm %temptext) { set %wngrnd.unknown 1 }
    if (*</a></font></th>* iswm %temptext) && (*weekday* iswm %temptext) { 
      inc %wngrnd.forecastDetailsPlacement
      set %wngrnd.forecastDetails. [ $+ [ %wngrnd.forecastDetailsPlacement ] ] www.wunderground.com $+ $gettok(%temptext,2,34)
    }
    if (*5-Day Forecast for ZIP Code* iswm %temptext) { set %wngrnd.forecastReceive 1 }
    if (*Click <b>Detail</b>* iswm %temptext) && (%wngrnd.forecastReceive == 1) { set %wngrnd.receive 0 }
    if (*border=1 width=44 height=44>* iswm %temptext) { did -g wngrnd 33 $findfile($shortfn($scriptdir),$replace($gettok($gettok(%temptext,2,34),-1,47),.GIF,.BMP),1) }
    if (*<td valign=top align=center ><img src="http://icons.wunderground.com/graphics/conds/* iswm %temptext) && (%wngrnd.forecastReceive == 1) { 
      inc %wngrnd.forecastHiLoPlacement 2
      did -g wngrnd %wngrnd.forecastPicPlacement $findfile($shortfn($scriptdir),$replace($gettok($gettok(%temptext,2,34),-1,47),.GIF,.BMP),1)
      did -a wngrnd %wngrnd.forecastHiLoPlacement $replace($nohtml(%temptext),&deg;,F)
      inc %wngrnd.forecastPicPlacement 2
    }
    if (*<td valign=top align=center class=smalltable >* iswm %temptext) {
      inc %wngrnd.forecastInfoPlacement
      did -a wngrnd %wngrnd.forecastInfoPlacement $nohtml(%temptext) 
    }
    if (*<th valign=middle class=smalltable width="20%" bgcolor=#DDDDDD>* iswm %temptext) && (%wngrnd.forecastReceive == 1) {
      inc %wngrnd.forecastDayPlacement
      did -a wngrnd %wngrnd.forecastDayPlacement $nohtml(%temptext)
    }
  }
}
ON *:SOCKOPEN:wngrnd:{ 
  if (%wngrnd.specifyLocation != 1) {
    sockwrite -n $sockname GET /cgi-bin/findweather/getForecast?query= $+ %wngrnd.location HTTP/1.0
  }
  else {
    sockwrite -n $sockname GET %wngrnd.location HTTP/1.0
  }
  sockwrite -n $sockname Host: printer.wunderground.com
  sockwrite -n $sockname Connection: close
  sockwrite -n $sockname $crlf
} 
on *:sockread:wngrnd:{
  if ($sockerr) {
    echo -a Error.
    halt
  }
  else {
    var %temptext
    sockread %temptext
    if (%wngrnd.getTemp == 1) && (*<b>*</b>&nbsp;&#176;F* iswm %temptext) {
      set %wngrnd.tempCache $remove($replace($nohtml(%temptext),&#176;F,F),&nbsp;)
    }
    if (%wngrnd.getTemp == 1) && (*<b>*</b>&nbsp;&#176;C* iswm %temptext) {
      did -a wngrnd 34 %wngrnd.tempCache $chr(47) $remove($replace($nohtml(%temptext),&#176;C,C),&nbsp;)
      unset %wngrnd.tempCache
      unset %wngrnd.getTemp
    }
    if (%wngrnd.getWindchill == 1) && (*<b>*</b>&nbsp;&#176;F* iswm %temptext) {
      set %wngrnd.wcCache $remove($replace($nohtml(%temptext),&#176;F,F),&nbsp;)
    }
    if (%wngrnd.getWindchill == 1) && (*<b>*</b>&nbsp;&#176;C* iswm %temptext) {
      did -a wngrnd 21 Windchill: %wngrnd.wcCache $chr(47) $remove($replace($nohtml(%temptext),&#176;C,C),&nbsp;)
      unset %wngrnd.getWindchill
      unset %wngrnd.wcCache
    }
    if (%wngrnd.getHumidity == 1) && (*<td><b>*</b></td></tr>* iswm %temptext) {
      did -a wngrnd 22 Humidity: $nohtml(%temptext)
      unset %wngrnd.getHumidity
    }
    if (%wngrnd.getDewP == 1) && (*<b>*</b>&nbsp;&#176;F* iswm %temptext) {
      set %wngrnd.dewCache $remove($replace($nohtml(%temptext),&#176;F,F),&nbsp;)
    }
    if (%wngrnd.getDewP == 1) && (*<b>*</b>&nbsp;&#176;C* iswm %temptext) {
      did -a wngrnd 23 Dewpoint: %wngrnd.dewCache $chr(47) $remove($replace($nohtml(%temptext),&#176;C,C),&nbsp;)
      unset %wngrnd.dewCache
      unset %wngrnd.getDewP
    }
    if (%wngrnd.getWind == 1) && (*<b>*</b>&nbsp;mph* iswm %temptext) {
      set %wngrnd.windCache $remove($nohtml(%temptext),&nbsp;)
    }
    if (%wngrnd.getWind == 1) && (*<b>*</b>&nbsp;km/h* iswm %temptext) {
      did -a wngrnd 24 Wind: %wngrnd.windCache $chr(47) $remove($nohtml(%temptext),&nbsp;)
      unset %wngrnd.windCache
      unset %wngrnd.getWind
    }
    if (%wngrnd.getPressure == 1) && (*<b>*</b>&nbsp;in* iswm %temptext) {
      set %wngrnd.pressureCache $remove($nohtml(%temptext),&nbsp;)
    }
    if (%wngrnd.getPressure == 1) && (*<b>*</b>&nbsp;hPa* iswm %temptext) {
      did -a wngrnd 25 Pressure: %wngrnd.pressureCache $chr(47) $remove($nohtml(%temptext),&nbsp;)
      unset %wngrnd.getPressure
      unset %wngrnd.pressureCache
    }
    if (%wngrnd.getCond == 1) && (*<td><b>*</b></td></tr>* iswm %temptext) {
      did -a wngrnd 36 $nohtml(%temptext)
      unset %wngrnd.getcond
    }
    if (%wngrnd.getVis == 1) && (*<b>*</b>&nbsp;miles* iswm %temptext) {
      set %wngrnd.visCache $remove($nohtml(%temptext),&nbsp;)
    }
    if (%wngrnd.getVis == 1) && (*<b>*</b>&nbsp;kilometers* iswm %temptext) {
      did -a wngrnd 20 Visibility: %wngrnd.visCache $chr(47) $replace($remove($nohtml(%temptext),&nbsp;),kilometers,km)
      unset %wngrnd.getVis
      unset %wngrnd.visCache
    }
    if (*<td>Temperature</td>* iswm %temptext) { set %wngrnd.getTemp 1 }
    if (*<td>Windchill</td>* iswm %temptext) { set %wngrnd.getWindchill 1 }
    if (*<td>Humidity</td>* iswm %temptext) { set %wngrnd.getHumidity 1 }
    if (*<td>Dew Point</td>* iswm %temptext) { set %wngrnd.getDewP 1 }
    if (*<td>Wind</td>* iswm %temptext) { set %wngrnd.getWind 1 }
    if (*<td>Pressure</td>* iswm %temptext) { set %wngrnd.getPressure 1 }
    if (*<td>Conditions</td>* iswm %temptext) { set %wngrnd.getCond 1 }
    if (*<td>Visibility</td>* iswm %temptext) { set %wngrnd.getVis 1 }
    if (*Updated: <b>* iswm %temptext) { 
      dialog -t wngrnd $dialog(wngrnd).title - $remove($nohtml(%temptext),Updated: ,Observed at)  
    }
    if (*<center><h1>* iswm %temptext) { 
      dialog -t wngrnd Weather Underground - $remove($nohtml(%temptext),Forecast and Conditions for ,$chr(9) ) 
    }
    if (*<th colspan=4>Temperature</th>* iswm %temptext) { set %wngrnd.receive 0 }
  }
}
on *:sockclose:wngrnd*:{
  if ($dialog(PWeatherS)) {
    var %i 1
    while (%i < $lines($shortfn($scriptdir $+ PWeather.txt))) {
      if ($read($shortfn($scriptdir $+ PWeather.txt),w,* $+ $did(PWeatherS,1) $+ *) == $read($shortfn($scriptdir $+ PWeather.txt),%i)) {
        set %wngrnd.PWeatherS.info $replace($replace($remove($read($shortfn($scriptdir $+ PWeather.txt),$calc(%i * 2)),&),#176;,),$chr(32) $+ F,F,$chr(32) $+ C,C,$chr(32) $+ in,in,$chr(32) $+ hPa,hPa,$chr(32) $+ mm,mm)
        set %wngrnd.PWeatherS.title $remove($read($shortfn($scriptdir $+ PWeather.txt),w,* $+ $did(PWeatherS,1) $+ *),Location: )
        if ($dialog(PWeatherS)) { dialog -x PWeatherS PWeatherS }
        dialog -dm PWeatherS PWeatherS
      }
      if (*Location:* iswm $read($shortfn($scriptdir $+ PWeather.txt),%i)) {
        inc %i 2
      }
    }
  }
  if (%wngrnd.specifyLocation == 1) {
    if (!$dialog(Location)) { dialog -dm Location Location }
    halt
  }
  if (%wngrnd.unknown == 1) { 
    dialog -t wngrnd Weather Underground - Unknown Location
    unset %wngrnd.unknown 
    halt 
  }
  unset %i
  var %i 0
  while (%i < 5) { 
    inc %i
    if ($len($did(wngrnd,%i)) == 2) {
      did -g wngrnd %i $shortfn($scriptdir $+ unknown.BMP)
    }
  }
  if ($len($did(wngrnd,33)) == 2) { did -g wngrnd 33 $shortfn($scriptdir $+ unknown.BMP) }
  if ($did(wngrnd,34) == $null) { did -a wngrnd 34 N/A }
  if ($did(wngrnd,36) == $null) { did -a wngrnd 36 N/A }
  if ($did(wngrnd,20) == Visibility:) { did -a wngrnd 20 Visibility: N/A }
  if ($did(wngrnd,21) == Wind Chill:) { did -a wngrnd 21 Wind Chill: N/A }
  if (%wunderground.metric == $true) {
    var %i 2
    while (%i < 12) {
      if ($findnum($did(wngrnd,%i),1) != $null) && ($findnum($did(wngrnd,%i),2) != $null) {
        set %wunderground.previousT. [ $+ [ %i ] ] $did(wngrnd,%i)
        did -a wngrnd %i $round($calc(($findnum($did(wngrnd,%i),1) - 32) * (5 / 9)),0) $+ C $chr(124) $round($calc(($findnum($did(wngrnd,%i),2) - 32) * (5 / 9)),0) $+ C
      }
      inc %i 2
    }
  }
}
dialog PWeatherS {
  title "Personal Weather Station"
  size -1 -1 121 86
  option dbu
  text "", 1, 1 1 119 14, center
  text "Temperature:", 2, 1 17 119 8
  text "Dew Point:", 3, 1 27 119 8
  text "Wind:", 4, 1 47 119 8
  text "Humidity:", 5, 1 37 119 8
  text "Windchill:", 6, 1 77 119 8
  text "Pressure:", 7, 1 57 119 8
  text "Hourly Precipitation:", 8, 1 67 119 8
}
dialog PWeather {
  title "Personal Weather Stations"
  size -1 -1 165 62
  option dbu
  list 1, 2 2 160 44, size hsbar vsbar
  button "OK", 2, 19 49 37 12, default
  button "Cancel", 3, 108 49 37 12
}
dialog Location {
  title "Specify Location"
  size -1 -1 165 62
  option dbu
  list 1, 2 2 160 44, size hsbar vsbar
  button "OK", 2, 19 49 37 12, default
  button "Cancel", 3, 108 49 37 12
}
dialog wngrnd {
  title "Weather Underground"
  size -1 -1 268 90
  option dbu
  icon 1, 11 12 20 20
  text "High | Low", 2, 6 34 30 8, center
  icon 3, 54 12 20 20
  text "High | Low", 4, 49 34 30 8, center
  icon 5, 96 12 20 20
  text "High | Low", 6, 90 34 30 8, center
  icon 7, 138 12 20 20
  text "High | Low", 8, 133 34 30 8, center
  icon 9, 180 12 20 20
  text "High | Low", 10, 175 34 30 8, center
  box "", 11, 1 6 43 54
  box "", 12, 43 6 43 54
  box "", 13, 127 6 43 54
  box "", 14, 85 6 43 54
  box "", 15, 169 6 43 54
  edit "Zip Code Here", 16, 3 62 50 10
  button "Get Forecast!", 17, 8 73 37 12, default flat
  box "", 18, 1 56 55 32
  box "", 19, 55 56 157 32
  text "Wind Chill:", 21, 58 70 65 8
  text "Humidity:", 22, 126 70 83 8
  text "Dew Point:", 23, 58 61 65 8
  text "Wind:", 24, 58 79 65 8
  text "Pressure:", 25, 126 61 83 8
  text "Info", 26, 2 43 40 15, center
  text "Info", 27, 44 43 40 15, center
  text "Info", 28, 86 43 40 15, center
  text "Info", 29, 128 43 40 15, center
  text "Info", 30, 170 43 41 14, center
  text "Current Conditions:", 32, 214 13 49 8
  icon 33, 224 25 26 25
  text "", 34, 227 51 20 14, center
  box "", 35, 211 6 55 82
  text "", 36, 218 67 39 18, center
  text "Visibility:", 20, 126 79 83 8
  text "", 37, 9 1 25 8, center
  text "", 38, 51 1 25 8, center
  text "", 39, 94 1 25 8, center
  text "", 40, 135 1 25 8, center
  text "", 41, 177 1 25 8, center
  menu "Menu", 42
  item "Metric units", 44, 42
  item "English units", 45, 42
  item "Personal Weather Stations", 46, 42
}
on *:dialog:PWeatherS:init:0:{
  did -a PWeatherS 1 %wngrnd.PWeatherS.title
  did -a PWeatherS 2 Temperature: $gettok(%wngrnd.PWeatherS.info,1,32) / $gettok(%wngrnd.PWeatherS.info,2,32)
  did -a PWeatherS 3 Dew Point: $gettok(%wngrnd.PWeatherS.info,3,32) / $gettok(%wngrnd.PWeatherS.info,4,32)
  did -a PWeatherS 5 Humidity: $gettok(%wngrnd.PWeatherS.info,5,32)
  if (*Calm* !iswm $gettok(%wngrnd.PWeatherS.info,6,32)) {
    did -a PWeatherS 4 Wind: $mid2(%wngrnd.PWeatherS.info,$calc($pos(%wngrnd.PWeatherS.info,$chr(37),1) + 1),$calc($pos(%wngrnd.PWeatherS.info,/,1) + 1))
  }
  else {
    did -a PWeatherS 4 Wind: Calm
  }
  if (*C* !iswm $gettok(%wngrnd.PWeatherS.info,-1,32)) && (*-* !iswm $gettok(%wngrnd.PWeatherS.info,-1,32)) {
    did -a PWeatherS 6 Windchill: N/A
    did -a PWeatherS 7 Pressure: $gettok(%wngrnd.PWeatherS.info,-4,32) / $gettok(%wngrnd.PWeatherS.info,-3,32)
    did -a PWeatherS 8 Hourly Precipitation: $gettok(%wngrnd.PWeatherS.info,-2,32) / $gettok(%wngrnd.PWeatherS.info,-1,32)
  }
  else if (*C* iswm $gettok(%wngrnd.PWeatherS.info,-1,32)) {
    did -a PWeatherS 6 Windchill: $gettok(%wngrnd.PWeatherS.info,-2,32) / $gettok(%wngrnd.PWeatherS.info,-1,32)
    did -a PWeatherS 7 Pressure: $gettok(%wngrnd.PWeatherS.info,-6,32) / $gettok(%wngrnd.PWeatherS.info,-5,32)
    did -a PWeatherS 8 Hourly Precipitation: $gettok(%wngrnd.PWeatherS.info,-4,32) / $gettok(%wngrnd.PWeatherS.info,-3,32)
  }
  else if (*-* iswm $gettok(%wngrnd.PWeatherS.info,-1,32)) {
    did -a PWeatherS 6 Windchill: N/A
    did -a PWeatherS 7 Pressure: $gettok(%wngrnd.PWeatherS.info,-5,32) / $gettok(%wngrnd.PWeatherS.info,-4,32)
    did -a PWeatherS 8 Hourly Precipitation: $gettok(%wngrnd.PWeatherS.info,-3,32) / $gettok(%wngrnd.PWeatherS.info,-2,32)
  }
}
on *:dialog:PWeather:sclick:2:{
  if ($did(PWeather,1).sel != $null) {
    set %wngrnd.PWeatherS.info $replace($replace($remove($read($shortfn($scriptdir $+ PWeather.txt),$calc($did(PWeather,1).sel * 2)),&),#176;,),$chr(32) $+ F,F,$chr(32) $+ C,C,$chr(32) $+ in,in,$chr(32) $+ hPa,hPa,$chr(32) $+ mm,mm)
    set %wngrnd.PWeatherS.title $did(PWeather,1).seltext
    dialog -x PWeather PWeather
    if ($dialog(PWeatherS)) { dialog -x PWeatherS PWeatherS }
    dialog -dm PWeatherS PWeatherS
  }
}
on *:dialog:PWeather:dclick:1:{
  if ($did(PWeather,1).sel != $null) {
    set %wngrnd.PWeatherS.info $replace($replace($remove($read($shortfn($scriptdir $+ PWeather.txt),$calc($did(PWeather,1).sel * 2)),&),#176;,),$chr(32) $+ F,F,$chr(32) $+ C,C,$chr(32) $+ in,in,$chr(32) $+ hPa,hPa,$chr(32) $+ mm,mm)
    set %wngrnd.PWeatherS.title $did(PWeather,1).seltext
    dialog -x PWeather PWeather
    if ($dialog(PWeatherS)) { dialog -x PWeatherS PWeatherS }
    dialog -dm PWeatherS PWeatherS
  }
}
on *:dialog:PWeather:init:0:{
  var %i 1
  while (%i < $lines($shortfn($scriptdir $+ PWeather.txt))) {
    did -a PWeather 1 $remove($read($shortfn($scriptdir $+ PWeather.txt),%i),Location: )
    inc %i 2
  }
}
on *:dialog:PWeather:sclick:3:{
  dialog -x PWeather PWeather
}
on *:dialog:wngrnd:menu:46:{
  dialog -dm PWeather PWeather
}
on *:dialog:wngrnd:init:0:{
  did -b wngrnd 46
}
on *:dialog:wngrnd:menu:44:{
  if (%wunderground.metric == $false) {
    did -b wngrnd 44
    did -e wngrnd 45
    set %wunderground.metric $true
    var %i 2
    while (%i < 12) {
      if ($findnum($did(wngrnd,%i),1) != $null) && ($findnum($did(wngrnd,%i),2) != $null) {
        set %wunderground.previousT. [ $+ [ %i ] ] $did(wngrnd,%i)
        did -a wngrnd %i $round($calc(($findnum($did(wngrnd,%i),1) - 32) * (5 / 9)),0) $+ C $chr(124) $round($calc(($findnum($did(wngrnd,%i),2) - 32) * (5 / 9)),0) $+ C
      }
      inc %i 2
    }
  }
}
on *:dialog:wngrnd:menu:45:{
  if (%wunderground.metric == $true) {
    set %wunderground.metric $false
    did -e wngrnd 44
    did -b wngrnd 45
    var %i 2
    while (%i < 12) {
      if ($findnum($did(wngrnd,%i),1) != $null) && ($findnum($did(wngrnd,%i),2) != $null) {
        if (%wunderground.previousT. [ $+ [ %i ] ] != $null) {
          did -a wngrnd %i %wunderground.previousT. [ $+ [ %i ] ]
        }
        else {
          did -a wngrnd %i $round($calc(($findnum($did(wngrnd,%i),1) + 32) * (9 / 5)),0) $+ F $chr(124) $round($calc(($findnum($did(wngrnd,%i),2) + 32) * (9 / 5)),0) $+ F
        }
      }
      inc %i 2
    }
  }
}
on *:dialog:Location:init:0:{
  var %i 0
  while (%i < %wngrnd.locationAmount) {
    inc %i
    did -a Location 1 %wngrnd.locationName. [ $+ [ %i ] ]
  }
}
on *:dialog:Location:dclick:1:{
  if (!$did(Location,1).seltext) {
    dialog -t Location Specify Location - You must select a location!
  }
  else {
    if ($dialog(wngrnd)) {
      set %wngrnd.location %wngrnd.locationHref. [ $+ [ $did(Location,1).sel ] ]
      weather
      dialog -x Location Location
      unset %wngrnd.locationHref.*
      unset %wngrnd.locationName.*
    }
  }
}
on *:dialog:Location:sclick:2:{
  if (!$did(Location,1).seltext) {
    dialog -t Location Specify Location - You must select a location!
  }
  else {
    if ($dialog(wngrnd)) {
      set %wngrnd.location %wngrnd.locationHref. [ $+ [ $did(Location,1).sel ] ]
      weather
      dialog -x Location Location
      unset %wngrnd.locationHref.*
      unset %wngrnd.locationName.*
    }
  }
}
on *:dialog:Location:sclick:3:{
  dialog -x Location Location
  unset %wngrnd.specifyLocation
  unset %wngrnd.locationHref.*
  unset %wngrnd.locationName.*
}
on *:dialog:Location:close:0:{
  unset %wngrnd.specifyLocation
}
on *:dialog:wngrnd:dclick:1:{
  url %wngrnd.forecastDetails.1
}
on *:dialog:wngrnd:dclick:3:{
  url %wngrnd.forecastDetails.2
}
on *:dialog:wngrnd:dclick:5:{
  url %wngrnd.forecastDetails.3
}
on *:dialog:wngrnd:dclick:7:{
  url %wngrnd.forecastDetails.4
}
on *:dialog:wngrnd:dclick:9:{
  url %wngrnd.forecastDetails.5
}
on *:dialog:wngrnd:sclick:17:{
  if ($did(wngrnd,16) != $null) {
    weather $did(wngrnd,16)
  }
}
alias nohtml {
  var %tmp, %ignore = $regsub($1-,/(<[^>]+>)/g,$chr(32),%tmp)
  return $replace(%tmp,&nbsp;,$null)
}
alias mid2 {
  if ($1) && ($2) && ($3) {
    var %x 0
    while (%x < $len($1)) {
      inc %x
      if (%x == $2) {
        set %startP %x
      }
      if (%x == $3) {
        set %endP $calc($calc(%x - %startP) + 1)
      }
    }
  }
  else {
    return $chr(36) $+ null
  }
  return $mid($1,%startP,%endP)
  unset %startP, %endP
}
alias findnum {
  if ($isid) {
    var %i 0
    unset %toreturn
    while (%i < $regex($1-,/(\d{1 $+ $chr(44) $+ 100})/g)) {
      inc %i
      if ($2) {
        set %toreturn $regml($2)
      }
      else {
        set %toreturn %toreturn $regml(%i)
      }
    }
    return %toreturn
  }
}
alias uninstall {
  if ($dialog(wngrnd)) { dialog -x wngrnd wngrnd }
  unset %wngrnd*
  unset %wunderground*
  echo -a Successfully Unloaded Weather Underground
  .unload -rs wunderground.mrc
}
on *:unload:{
  if ($dialog(wngrnd)) { dialog -x wngrnd wngrnd }
  unset %wngrnd*
  unset %wunderground*
  echo -a Successfully Unloaded Weather Underground
  .unload -rs wunderground.mrc
}
